/*****************************************************************
 * skin_data.c
 *
 * Copyright(C)2003, Julien Delacroix
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GPL.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "skin_data.h"
#include "skin_parsing.h"

int get_length(char *param, XML_Parser p){
  int value = atoi(param);
  if (value < LENGTH_MIN){
    fprintf(stderr, "SKIN FILE IS BROKEN!\n"
	    "Invalid length at line %d : value is too low !!\n"
	    "I assume you mean %d (minimal value)...\n",
	    XML_GetCurrentLineNumber(p), LENGTH_MIN);
    return LENGTH_MIN;
  }
  if (value > LENGTH_MAX){
    fprintf(stderr, "SKIN FILE IS BROKEN!\n"
	    "Invalid length at line %d : value is too high !!\n"
	    "I assume you mean %d (maximal value)...\n",
	    XML_GetCurrentLineNumber(p), LENGTH_MAX);
    return LENGTH_MAX;
  }
  return value;
}

int get_content(char *param, XML_Parser p){
  if(!strcmp(param,"login"))
    return LOGIN;
  if(!strcmp(param,"talk"))
    return TALK;
  if(!strcmp(param,"idle"))
    return IDLE;
  if(!strcmp(param,"room"))
    return ROOM;
  if(!strcmp(param,"computer"))
    return COMP;
  if(!strcmp(param,"name"))
    return NAME;
  fprintf(stderr, "***BAD*** SKIN FILE IS REALLY BROKEN!\n"
	  "Invalid content at line %d:\n"
	  "Arrgh! I can't understand, please help !!\n"
	  "I will skip all this column...\n",
	  XML_GetCurrentLineNumber(p));
  return INVALID;
}

int get_style(char *param, XML_Parser p){
  if(!strcmp(param,"default"))
    return DEFAULT;
  if(!strcmp(param,"bold"))
    return BOLD;
  if(!strcmp(param,"underlined"))
    return UNDERLINED;
  if(!strcmp(param,"blink"))
    return BLINK;
  if(!strcmp(param,"reverse"))
    return REVERSE;
  else{
    fprintf(stderr, "SKIN FILE IS BROKEN!\n"
	    "Invalid style at line %d:\n"
	    "I assume you mean 'default'...\n",
	    XML_GetCurrentLineNumber(p));
    return DEFAULT;
  }
}


int get_alignment(char *param, XML_Parser p){
  if(!strcmp(param,"center"))
    return CENTER;
  if(!strcmp(param,"left"))
    return LEFT;
  if(!strcmp(param,"right"))
    return RIGHT;
  else{
    fprintf(stderr, "SKIN FILE IS BROKEN!\n"
	    "Invalid alignment at line %d:\n"
	    "I assume you mean 'left'...\n",
	    XML_GetCurrentLineNumber(p));
    return LEFT;
  }
}


int get_color(char *param, XML_Parser p){
  if(!strcmp(param,"black"))
    return BLACK;
  if(!strcmp(param,"red"))
    return RED;
  if(!strcmp(param,"green"))
    return GREEN;
  if(!strcmp(param,"yellow"))
    return YELLOW;
  if(!strcmp(param,"blue"))
    return BLUE;
  if(!strcmp(param,"pink"))
    return PINK;
  if(!strcmp(param,"cyan"))
    return CYAN;
  if(!strcmp(param,"white"))
    return WHITE;
  if(!strcmp(param,"default"))
    return DEFAULT;
  
  else{
    fprintf(stderr, "SKIN FILE IS BROKEN!\n"
	    "Invalid color at line %d:\n"
	    "I assume you mean 'default'...\n",
	    XML_GetCurrentLineNumber(p));
    return DEFAULT;
  }
}






