/*****************************************************************
 * skin_data.c
 *
 * Copyright(C)2003, Julien Delacroix
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GPL.
 *
 */

#ifndef SKIN_DATA_H
#define SKIN_DATA_H
#include "../expat/xmlparse/xmlparse.h"

/* CONSTANTS */
/* general */
#define TRUE  1
#define FALSE 0
#define DEFAULT -1
#define INVALID -1

/* contents */
#define LOGIN 0
#define TALK  1
#define IDLE  2
#define ROOM  3
#define COMP  4
#define NAME  6

/* colors */
#define BLACK 0
#define RED 1
#define GREEN 2
#define YELLOW 3
#define BLUE 4
#define PINK 5
#define CYAN 6
#define WHITE 7


#define FOREGROUND 30
#define BACKGROUND 40

/* styles */
#define BOLD 1
#define UNDERLINED 4
#define BLINK 5
#define REVERSE 7

/* alignments */
#define CENTER 1
#define LEFT 2
#define RIGHT 3

/* length restrictions */
#define LENGTH_MIN 5
#define LENGTH_MAX 50

/* STRUCTURES */
struct cell{
  int fg_color;  
  int bg_color;  
  int style;     
  int alignment; 
};

struct column{
  char *title;    
  int content;
  int length;     
  struct cell *title_format;
  struct cell *default_format;
  struct column *next; 
};

/* MACROS */
#define SKIN_LIST_APPEND(head,value) \
  value->next=NULL; \
  if(head==NULL) \
    head=value; \
  else \
  { \
    struct column *tamp; \
    for(tamp=head;tamp->next!=NULL;tamp=tamp->next); \
    tamp->next=value; \
  }

/* FUNCTIONS */
int get_length(char *param, XML_Parser p);
int get_content(char *param, XML_Parser p);
int get_style(char *param, XML_Parser p);
int get_alignment(char *param, XML_Parser p);
int get_color(char *param, XML_Parser p);

#endif
