/*****************************************************************
 * skin_parsing.h
 *
 * Copyright(C)2003, Julien Delacroix
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GPL.
 *
 */

#ifndef SKIN_PARSING_H
#define SKIN_PARSING_H
#include "../expat/xmlparse/xmlparse.h"

/* CONSTANTS */
/* context info tags */
#define NONE    0
#define TITLE   1
#define CONTENT 2 /* title string */
#define LENGTH  3
#define FG      4
#define BG      5
#define STYLE   6
#define ALIGN   7

/* STRUCTURES */
struct context_info{
  int depth;
  int last_tag;
  int waiting_for_text;

  struct cell *current_cell; 
  struct column *current_column; 
  struct column *skin ;
  XML_Parser parser;
 };

/* FUNCTIONS */
void start_hndl(void *data, const char *el, const char **attr);
void end_hndl(void *data, const char *el);
void char_hndl(void *data, const char *txt, int txtlen);
struct context_info *initialise_context_info(XML_Parser p);
struct column *skin_parse(char *fp);

#endif



