#include "trace.h"

#include <stdio.h>
#include <locale.h>

int trace (const char * login)
{
	int status = 0 ;
	char name [99] ;
	trace_from unixFrom ;
	trace_from winFrom ;
	trace_from * lastFrom ;
	trace_logs logs = {NULL, 0} ;
	int logsNb ;

	if (! login)
		return -1 ;
	setlocale (LC_TIME, "") ;

	if (! getName (login, name, 99))
	{
		printf ("login inexistant\n") ;
		goto finally ;
	}

	if (trace_getUnixFrom (login, & unixFrom))
	{
		status = -1 ;
		goto finally ;
	}

	if (trace_getWinFrom (& winFrom))
	{
		status = -1 ;
		goto finally ;
	}

	logsNb = trace_getLogsNb (login) ;
	if (logsNb < 0)
	{
		status = -1 ;
		goto finally ;
	}
	logsNb += 3 ;

	logs.logsArray = malloc (logsNb * sizeof (trace_log)) ;
	if (! logs.logsArray)
	{
		status = -1 ;
		goto finally ;
	}

	if (trace_getUnixLogs (login, & logs))
	{
		status = -1 ;
		goto finally ;
	}

	if (trace_getWinLogs (login, & logs))
	{
		status = -1 ;
		goto finally ;
	}

	lastFrom = trace_getLastFrom (& unixFrom, & winFrom) ;
	if (! lastFrom)
	{
		status = -1 ;
		goto finally ;
	}

	if (trace_printHeader (name, lastFrom))
	{
		status = -1 ;
		goto finally ;
	}

	qsort (logs.logsArray, logs.logsNb, sizeof (trace_log), (int (*) (const void *, const void *)) trace_compareLog) ;

	if (trace_printLogsAfter (& logs, lastFrom))
	{
		status = -1 ;
		goto finally ;
	}

finally :
	if (logs.logsArray)
		free (logs.logsArray) ;

	return status ;
}
