#ifndef TRACE_H
#define TRACE_H

#include <stdlib.h>

#define TIME_NOT_YET	-1
#define TIME_UNKNOWN	-2

typedef struct
{
	char os ; /* 'u' = Unix, 'w' = Windows */
	int year ;
	int month ; /* 0..11 */
	int day ; /* 0..30 */
	int beginHour ;
	int beginMin ;
	int endHour ;
	int endMin ;
	char host [30] ;
} trace_log ;

typedef struct
{
	trace_log * logsArray ;
	int logsNb ;
} trace_logs ;

typedef struct
{
	int year ;
	int month ; /* 0..11 */
	int day ; /* 0..30 */
	int hour ;
	int min ;
} trace_from ;

int trace (const char * login) ;

char * getName (const char * login, char * name, const size_t n) ;
int getMonthI (const char * month, const char * locale) ;

int trace_getUnixFrom (const char * login, trace_from * unixFrom) ;
int trace_getWinFrom (trace_from * winFrom) ;
int trace_getUnixLogs (const char * login, trace_logs * unixLogs) ;
int trace_getWinLogs (const char * login, trace_logs * winLogs) ;
int trace_getLogsNb (const char * login) ;

int trace_compareLog (const trace_log * log1, const trace_log * log2) ;
int trace_compareFrom (const trace_from * from1, const trace_from * from2) ;
trace_from * trace_getLastFrom (trace_from * from1, trace_from * from2) ;
int trace_compareLogFrom (const trace_log * log, const trace_from * from) ;

int trace_printMonth (const int month) ;
int trace_printDay (const int year, const int month, const int day) ;
int trace_printTime (const int hour, const int min) ;
int trace_printHeader (const char * name, const trace_from * from) ;
int trace_printLog (const trace_log * log) ;
int trace_printLogsAfter (const trace_logs * logs, const trace_from * from) ;

#endif
