#include "trace.h"

int trace_compareLog (const trace_log * log1, const trace_log * log2)
{
	if (! log1 && ! log2)
		return 0 ;
	if (! log1)
		return 1 ;
	if (! log2)
		return -1 ;
	if (log1->year == log2->year)
	{
		if (log1->month == log2->month)
		{
			if (log1->day == log2->day)
			{
				if (log1->beginHour == log2->beginHour || log1->beginHour == TIME_UNKNOWN || log2->beginHour == TIME_UNKNOWN)
				{
					if (log1->beginMin == log2->beginMin || log1->beginHour == TIME_UNKNOWN || log2->beginHour == TIME_UNKNOWN)
					{
						if (log1->endHour == TIME_NOT_YET || log1->endHour == TIME_UNKNOWN)
							return 1 ;
						if (log2->endHour == TIME_NOT_YET || log2->endHour == TIME_UNKNOWN)
							return -1 ;
						if (log1->endHour == log2->endHour)
						{
							return log1->endMin - log2->endMin ;
						}
						return log1->endHour - log2->endHour ;
					}
					return log1->beginMin - log2->beginMin ;
				}
				return log1->beginHour - log2->beginHour ;
			}
			return log1->day - log2->day ;
		}
		return log1->month - log2->month ;
	}
	return log1->year - log2->year ;
}

int trace_compareFrom (const trace_from * from1, const trace_from * from2)
{
	if (! from1 && ! from2)
		return 0 ;
	if (! from1)
		return 1 ;
	if (! from2)
		return -1 ;
	if (from1->year == from2->year)
	{
		if (from1->month == from2->month)
		{
			if (from1->day == from2->day)
			{
				if (from1->hour == from2->hour)
				{
					return from1->min - from2->min ;
				}
				return from1->hour - from2->hour ;
			}
			return from1->day - from2->day ;
		}
		return from1->month - from2->month ;
	}
	return from1->year - from2->year ;
}

trace_from * trace_getLastFrom (trace_from * from1, trace_from * from2)
{
	return (trace_compareFrom (from1, from2) > 0 ? from1 : from2) ;
}

int trace_compareLogFrom (const trace_log * log, const trace_from * from)
{
	if (! log && ! from)
		return 0 ;
	if (! log)
		return 1 ;
	if (! from)
		return -1 ;
	if (log->year == from->year)
	{
		if (log->month == from->month)
		{
			if (log->day == from->day)
			{
				if (log->endHour == TIME_NOT_YET)
					return 1 ;
				if (log->endHour == from->hour)
				{
					return log->endMin - from->min ;
				}
				return log->endHour - from->hour ;
			}
			return log->day - from->day ;
		}
		return log->month - from->month ;
	}
	return log->year - from->year ;
}
